﻿using C1.WPF.DataGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;  
namespace ColResize_C1DataGrid
{
    public partial class MainWindow : Window
    {
        static string[] _labels = new string[] { "Column1", "Column2", "Column3", "Column4"};
        ObservableCollection<ChartTableValue> chartTableValues;
        public MainWindow()
        {
            InitializeComponent();

            chartTableValues = new ObservableCollection<ChartTableValue>();
            chartTableValues.Add(new ChartTableValue() { Label = "A" });
            chartTableValues.Add(new ChartTableValue() { Label = "B" });
            chartTableValues.Add(new ChartTableValue() { Label = "C" });
            chartTableValues.Add(new ChartTableValue() { Label = "D" });
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            SetColumnsAndRows(_grid, chartTableValues, new DependencyPropertyChangedEventArgs());
        }
        private static void SetColumnsAndRows(DependencyObject source, System.Collections.ObjectModel.ObservableCollection<ChartTableValue> columnsList, DependencyPropertyChangedEventArgs e)
        {
            var dataGrid = source as C1DataGrid;
            if (dataGrid == null || columnsList == null || columnsList.Count <= 0) return;

            DataTable dt = new DataTable();
            dt.Columns.Add("Column1", typeof(int));
            dt.Columns.Add("Column2", typeof(string));
            dt.Columns.Add("Column3", typeof(string));
            dt.Columns.Add("Column4", typeof(string));
            dt.Rows.Add(1, "Maria Anders", "Sales Representative", "Spain");
            dt.Rows.Add(2, "Ana Trujillo", "Sales Associate", "Mexico");
            dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland");
            dt.Rows.Add(4, "Thomas Hardy", "Sales Representative", "UK");
            dt.Rows.Add(5, "Patricio Simpson", "Marketing Manager", "Germany");
            dt.Rows.Add(6, "Paolo Accorti", "Sales Representative", "Spain");
            dt.Rows.Add(7, "Martine Rancé", "Owner", "Mexico");
            dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager", "UK");
            dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria");
            dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico");
            dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland");
            dt.Rows.Add(12, "Sergio Gutiérrezy", "Order Administrator", "Brazil");
            dataGrid.ItemsSource = dt.DefaultView;

            dataGrid.Columns.Clear();

            foreach (var label in _labels)
            {
                dataGrid.Columns.Add(new C1.WPF.DataGrid.DataGridTextColumn()
                {
                    Width = C1.WPF.DataGrid.DataGridLength.Auto,
                    Header = label,
                    Binding = new Binding(label.Replace(' ', '_')),
                    CanUserSort = false,
                    CanUserResizeRows = false,
                    CanUserMove = false,
                    CanUserResize = true,
                    CanUserGroup = false,
                    IsSelectable = false
                });
            }
            dataGrid.ColumnWidth = C1.WPF.DataGrid.DataGridLength.Auto;
            dataGrid.GridLinesVisibility = DataGridGridLinesVisibility.All;
            dataGrid.LoadedColumnHeaderPresenter += (s, f) =>
            {
                var colorBrush = Brushes.Red;   // IntToColor(_colors[f.Column.Index]);
                f.Column.Width = new DataGridLength(1, DataGridUnitType.Auto);
                f.Column.HeaderPresenter.HorizontalContentAlignment = HorizontalAlignment.Center;
                f.Column.HeaderPresenter.Background = colorBrush;
                f.Column.HeaderPresenter.Foreground =  Brushes.DarkBlue ; //BackgroundToForegroundColor(colorBrush);
            };
        }
    }
    public class ChartTableValue
    {
        public string Label { get; set; }
    }
}
